/*
 * rtg.c
 */

/*
 * Recursive Turtle Graphics
 *	Version : 0.1 (2015/05/08)
 */

#include <stdio.h>
#include <string.h>	/* strcmp を利用する場合に必要 */
#include "s_turtle.h"	/* turtle graphics の時に必要なおまじない */

/*
 * N Times
 *
 * 引数の文字列の長さによって、実行回数を指定できる関数群
 */

/*
 * s_n_times_turtle_move ( char *times )
 *	N Times Move : 引数 times の文字列の長さだけ move を繰り返す
 *	char *times : 繰り返す回数を文字列の長さで表現
 */

void s_n_times_turtle_move ( char *times ) {

  if ( !strcmp ( times, "" ) ) {
    /* do nothing */
  } else {
    s_turtle_move();
    s_n_times_turtle_move( times + 1 );
  }
}

/*
 * s_n_times_turtle_turn ( char *times )
 *	N Times Turn : 引数 times の文字列の長さだけ turn を繰り返す
 *	char *times : 繰り返す回数を文字列の長さで表現
 */

void s_n_times_turtle_turn ( char *times ) {

  if ( !strcmp ( times, "" ) ) {
    /* do nothing */
  } else {
    s_turtle_turn();
    s_n_times_turtle_turn( times + 1 );
  }
}

/*
 * s_n_times_turtle_jump ( char *times )
 *	N Times Jump : 引数 times の文字列の長さだけ jump を繰り返す
 *	char *times : 繰り返す回数を文字列の長さで表現
 */

void s_n_times_turtle_jump ( char *times ) {

  if ( !strcmp ( times, "" ) ) {
    /* do nothing */
  } else {
    s_turtle_jump();
    s_n_times_turtle_jump( times + 1 );
  }
}

/*
 * main 関数
 */

int main ( void ) {

  /* 一度目 */
  s_n_times_turtle_move ( "1234567890" );	/* 10 回 move */
  s_n_times_turtle_turn ( "12" );		/* 2 回 turn */

  /* ニ度目 */
  s_n_times_turtle_move ( "1234567890" );	/* 10 回 move */
  s_n_times_turtle_turn ( "12" );		/* 2 回 turn */

  /* 三度目 */
  s_n_times_turtle_move ( "1234567890" );	/* 10 回 move */
  s_n_times_turtle_turn ( "12" );		/* 2 回 turn */

  /* 四度目 */
  s_n_times_turtle_move ( "1234567890" );	/* 10 回 move */
  s_n_times_turtle_turn ( "12" );		/* 2 回 turn */

  return 0;
}

